"""Uses ldap to retrieve a list of brokers."""

import util, os

try:
	from subprocess import Popen,PIPE
	def queryLdap(t):
		os.environ["GLITE_SD_PLUGIN"] = "bdii"
		p = Popen(["glite-sd-query -e -t %s" % t], bufsize=1, stdin=PIPE, stdout=PIPE, stderr=PIPE,close_fds=True, shell=True)
		out, err = p.communicate()
		return out
	
except:
	from popen2 import Popen3
	def queryLdap(t):
		os.environ["GLITE_SD_PLUGIN"] = "bdii"
		p = Popen3("glite-sd-query -e -t %s" % t,1)
		p.tochild.close()
		out = p.fromchild.read()
		p.fromchild.close()
		err = p.childerr.read()
		p.childerr.close()
		p.wait()
		return out
	


def getBroker():
	types = ["msg.broker.rest", "msg.broker.stomp"]
	out = []
	for t in types:
		out.append(queryLdap(t))
	
	brokerlist = []
	for line in "".join(out).split("\n"):
		try:
			line = line.strip()
			if line:
				if line[:12] == "failover://(":
					b1, b2 = line[12:-1].split(",")
					brokerlist.append(b1)
					brokerlist.append(b2)
				elif line[:7] in ["stomp:/", "http://"]:
					brokerlist.append(line)	
		except:
			continue
	return util.getUrlsAsDicts(brokerlist)

if __name__ == "__main__":
	print getBroker()
