"""Tar interface using Popen

This module provides simple methods to create and extract tar balls

Author: Thomas Low <thomas.low@cern.ch>
"""

import os.path
try:
	from subprocess import Popen,PIPE
	def _runCommand(cmd, data):
		p = Popen([cmd], bufsize=1, stdin=PIPE, stdout=PIPE, stderr=PIPE,close_fds=True, shell=True)
		out, err = p.communicate(input=data)
		if err:
			raise Exception(err)
		return out

except:
	Popen = None
	from popen2 import Popen3
	def _runCommand(cmd, data):
		p = Popen3(cmd, 1)
		p.tochild.write(data)
		p.tochild.close()
		out = p.fromchild.read()
		p.fromchild.close()
		err = p.childerr.read()
		p.childerr.close()
		p.wait()
		if err:
			raise Exception(err)
		return out



def create(path, filelist):
	_runCommand("tar -cf %s %s" % (path, " ".join(filelist)), "")
	
def extract(path, directory="."):
	path = os.path.abspath(path)
	directory = os.path.abspath(directory)
	_runCommand("cd %s && tar -xf %s" % (directory, path), "")

